﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Gifitti.GifImageModule;

namespace Gifitti.Views
{
    public partial class MainForm : Form
    {
        GifModel gm;

        // GifImage _currentGif; <- used to encapsulate info later 
        private const int widthBuffer = 20;
        private const int heightBuffer = 60;
        Image globalGif;

        public MainForm()
        {

            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "GIF Files|*.gif";
            DialogResult result = openFileDialog1.ShowDialog(); // Show the dialog.
            if (result == DialogResult.OK) // Test result.
            {
                string file = openFileDialog1.FileName;
                try
                {


                    gm = new GifModel(file);
                    Image loadedGif = gm.gifImage.gifImage;
                    globalGif = loadedGif;
                    gifView.Image = loadedGif;

                    gifView.Width = loadedGif.Width;
                    gifView.Height = loadedGif.Height;
                    ClientSize = new Size(loadedGif.Width+widthBuffer, loadedGif.Height+heightBuffer);
                }

                catch (IOException)
                {
                }

                CenterToScreen();

                // Focus the gif:
                gifView.Select();
                gifView.Focus();
                ActiveControl = gifView;
            }
        }


        private void button2_Click(object sender, EventArgs e)
        {
            String x = "";
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                x = folderBrowserDialog1.SelectedPath;
            }

            List<Image> IMGs = new List<Image>();
            Image test;
            int Length = globalGif.GetFrameCount(FrameDimension.Time);

            for (int i = 0; i < Length; i++)
            {
                globalGif.SelectActiveFrame(FrameDimension.Time, i);
                test = new Bitmap(globalGif);
                String y = "\\tmp-" + i + ".bmp";
                String xy = x + y;
                test.Save(@xy);

            }
        }
            
        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void gifView_Click(object sender, EventArgs e)
        {

        }

        private void button3_Click(object sender, EventArgs e)
        {
            gm?.returnSubGif(1,10);

        }
    }
}
